#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Deck Builder
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Face Tool>Deck Builder
#		 Note:	Steps are placed on the shortest edge that is >= 24".  Spindle and Post definitions 
#						must be in the DB_Support_Files sub-directory.  The spindles must be 24" tall and the
#						posts 36" tall with axes located at bottom center.
#    Date:	Jun 2014
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item("Deck Builder") { Sketchup.active_model.select_tool SDM::Deck_Builder.new }
	tb=UI::Toolbar.new "DB"
	cmd=UI::Command.new("DB") { Sketchup.active_model.select_tool SDM::Deck_Builder.new }
	cmd.small_icon=cmd.large_icon=File.join(File.dirname(__FILE__).gsub('\\','/'),"DB_Support_Files/DB_Icon.jpg")
	cmd.tooltip="Deck Builder";tb.add_item cmd;tb.show
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	class Deck_Builder

		@@dlg=nil
		
		def initialize
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@vue=@mod.active_view
			@ip=Sketchup::InputPoint.new
			@path = File.join(File.dirname(__FILE__).gsub('\\','/'),'DB_Support_Files')
			@sp_files=Dir[@path+'/*.skp']; @sp_names = []; 
			@sp_files.each{|s| @mod.definitions.load s; @sp_names << File.basename(s,'.skp')}
			@current_units=Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
			self.dialog
			self.reset
		end
		
		def dialog
			if @current_units < 2
				Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]=0; 
				defaults=['2X6','0.5','0','2X8','24','spindle_a','Yes','Yes','Yes','Yes','Yes','post_a']
				dd,gw,@ROT,jd,js,@SN,@do_d,@do_j,@do_p,@do_s,@do_r,@PN=Sketchup.read_default("Deck Builder","inch specs",defaults)
				@DX,@DY=self.actual_size(dd);@GW=gw.to_l;@JX,@JY=self.actual_size(jd);@JS=js.to_l
			else
				Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]=2; 
				defaults=['38X140','13','0','38X184','610','spindle_a','Yes','Yes','Yes','Yes','Yes','post_a']
				dd,gw,@ROT,jd,js,@SN,@do_d,@do_j,@do_p,@do_s,@do_r,@PN=Sketchup.read_default("Deck Builder","mm specs",defaults)
				dx,dy=dd.split("X"); @DX=dx.to_l; @DY=dy.to_l; jx,jy=jd.split("X"); @JX=jx.to_l; @JY=jy.to_l; @JS=js.to_l
			end
			unless @@dlg
				@@dlg=UI::WebDialog.new("Deck Builder", false,"D_B",200,300,30,50,true)
				@@dlg.set_html(
					"<html>
						<body>
							<form action=''>
								<fieldset>
									<legend><font color='blue'><b>Deck Builder</b></font></legend>
									<select name='Decking Size' style='width:80px' onchange='optionchanged(name,value)'>
										#{@current_units>1 ? '<!--' : ''}
											<option value='2X4' #{dd=='2X4' ? 'selected' : ''}>2x4</option>
											<option value='2X6' #{dd=='2X6' ? 'selected' : ''}>2x6</option>
											<option value='2X8' #{dd=='2X8' ? 'selected' : ''}>2x8</option>
										#{@current_units>1 ? '-->' : '<!--'}
											<option value='38X89'  #{dd=='38X89' ? 'selected' : ''}>38X89</option>
											<option value='38X140' #{dd=='38X140' ? 'selected' : ''}>38x140</option>
											<option value='38X184' #{dd=='38X184' ? 'selected' : ''}>38x184</option>
										#{@current_units<2 ? '-->' : ''}
									</select> : Decking Size<br>
									<select name='Rotation' style='width:80px' onchange='optionchanged(name,value)'>
										<option value='0' selected>0</option>
										<option value='90' >90</option>
									</select> : Rotation<br>
									<select name='Joist Size' style='width:80px' onchange='optionchanged(name,value)'>
										#{@current_units>1 ? '<!--' : ''}
											<option value='2X6' #{jd=='2X6' ? 'selected' : ''}>2x6</option>
											<option value='2X8' #{jd=='2X8' ? 'selected' : ''}>2x8</option>
											<option value='2X10' #{jd=='2X10' ? 'selected' : ''}>2x10</option>
										#{@current_units>1 ? '-->' : '<!--'}
											<option value='38X140' #{jd=='38X140' ? 'selected' : ''}>38x140</option>
											<option value='38X184' #{jd=='38X184' ? 'selected' : ''}>38x184</option>
											<option value='38X235' #{jd=='38X235' ? 'selected' : ''}>38x235</option>
										#{@current_units<2 ? '-->' : ''}
									</select> : Joist Size<br>
									<select name='Joist Spacing' style='width:80px' onchange='optionchanged(name,value)'>
										#{@current_units>1 ? '<!--' : ''}
											<option value='16' #{js=='16' ? 'selected' : ''}>16</option>
											<option value='24' #{js=='24' ? 'selected' : ''}>24</option>
										#{@current_units>1 ? '-->' : '<!--'}
											<option value='406' #{js=='406' ? 'selected' : ''}>406</option>
											<option value='610' #{js=='610' ? 'selected' : ''}>610</option>
										#{@current_units<2 ? '-->' : ''}
									</select> : Joist Spacing<hr>
									<select name='Posts' style='width:90px' onchange='optionchanged(name,value)'>
										<option value='post_a' #{@PN=='post_a' ? 'selected' : ''}>Post_A</option>
										<option value='post_b' #{@PN=='post_b' ? 'selected' : ''}>Post_B</option>
										<option value='post_c' #{@PN=='post_c' ? 'selected' : ''}>Post_C</option>
										<!-- post options
										<option value='post_d' #{@PN=='post_d' ? 'selected' : ''}>Post_D</option>
										<option value='post_e' #{@PN=='post_e' ? 'selected' : ''}>Post_E</option>
										<option value='post_f' #{@PN=='post_f' ? 'selected' : ''}>Post_F</option>
										-->
									</select>
									<!-- post Icons -->
									#{@PN=='post_a' ? "<img src='#{@path}/post_a.jpg' align='top'/>" : ''}
									#{@PN=='post_b' ? "<img src='#{@path}/post_b.jpg' align='top'/>" : ''}
									#{@PN=='post_c' ? "<img src='#{@path}/post_c.jpg' align='top'/>" : ''}
									<!--
									#{@PN=='post_d' ? "<img src='#{@path}/post_d.jpg' align='top'/>" : ''}
									#{@PN=='post_e' ? "<img src='#{@path}/post_e.jpg' align='top'/>" : ''}
									#{@PN=='post_f' ? "<img src='#{@path}/post_f.jpg' align='top'/>" : ''}
									--><hr>
									<select name='Spindles' style='width:90px' onchange='optionchanged(name,value)'>
										<option value='spindle_a' #{@SN=='spindle_a' ? 'selected' : ''}>Spindle_A</option>
										<option value='spindle_b' #{@SN=='spindle_b' ? 'selected' : ''}>Spindle_B</option>
										<option value='spindle_c' #{@SN=='spindle_c' ? 'selected' : ''}>Spindle_C</option>
										<!-- spindle options
										<option value='spindle_d' #{@SN=='spindle_d' ? 'selected' : ''}>Spindle_D</option>
										<option value='spindle_e' #{@SN=='spindle_e' ? 'selected' : ''}>Spindle_E</option>
										<option value='spindle_f' #{@SN=='spindle_f' ? 'selected' : ''}>Spindle_F</option>
										-->
									</select>
									<!-- spindle Icons -->
									#{@SN=='spindle_a' ? "<img src='#{@path}/spindle_a.jpg' align='top'/>" : ''}
									#{@SN=='spindle_b' ? "<img src='#{@path}/spindle_b.jpg' align='top'/>" : ''}
									#{@SN=='spindle_c' ? "<img src='#{@path}/spindle_c.jpg' align='top'/>" : ''}
									<!--
									#{@SN=='spindle_d' ? "<img src='#{@path}/spindle_d.jpg' align='top'/>" : ''}
									#{@SN=='spindle_e' ? "<img src='#{@path}/spindle_e.jpg' align='top'/>" : ''}
									#{@SN=='spindle_f' ? "<img src='#{@path}/spindle_f.jpg' align='top'/>" : ''}
									--><hr>
									<input type='checkbox' name='DO_P' value='Yes' #{@do_p=='Yes' ? 'checked' : ''} onClick='optionchanged(name,value)'>Posts
									<input type='checkbox' name='DO_J' value='Yes' #{@do_j=='Yes' ? 'checked' : ''} onClick='optionchanged(name,value)'>Joists
									<input type='checkbox' name='DO_S' value='Yes' #{@do_s=='Yes' ? 'checked' : ''} onClick='optionchanged(name,value)'>Steps<br>   
									<input type='checkbox' name='DO_D' value='Yes' #{@do_d=='Yes' ? 'checked' : ''} onClick='optionchanged(name,value)'>Decking
									<input type='checkbox' name='DO_R' value='Yes' #{@do_r=='Yes' ? 'checked' : ''} onClick='optionchanged(name,value)'>Rails<br>
								</fieldset>
							</form>
							<script type='text/javascript'>
								function optionchanged(name,value)
								{
									window.location='skp:OptionChanged@'+name+'='+value;
								}
							</script>
						</body>
					</html>"
				)
				@@dlg.add_action_callback("OptionChanged") {|d,p|
					var,val = p.split("=")
					case var
						when "Decking Size" then dd=val
						when "Rotation" then @ROT = val
						when "Joist Size" then jd=val
						when "Joist Spacing" then  js=val
						when "Posts" then @PN = val
						when "Spindles" then @SN = val
						when "DO_D" then @do_d=='Yes' ? @do_d='No' : @do_d='Yes'
						when "DO_J" then @do_j=='Yes' ? @do_j='No' : @do_j='Yes'
						when "DO_P" then @do_p=='Yes' ? @do_p='No' : @do_p='Yes'
						when "DO_S" then @do_s=='Yes' ? @do_s='No' : @do_s='Yes'
						when "DO_R" then @do_r=='Yes' ? @do_r='No' : @do_r='Yes'
					end
					@DX,@DY = self.actual_size(dd);@JX,@JY = self.actual_size(jd);@JS =js.to_l;
					defaults=[dd,gw,@ROT,jd,js,@SN,@do_d,@do_j,@do_p,@do_s,@do_r,@PN]; 
					if @current_units<2
						Sketchup.write_default("Deck Builder","inch specs",defaults)
					else
						Sketchup.write_default("Deck Builder","mm specs",defaults)
					end
					@optionchanged=true;@@dlg.close;@@dlg=nil;self.dialog;@optionchanged=false
				}
				
				@@dlg.set_on_close { onCancel(nil,nil)  unless @optionchanged}
				
				RUBY_PLATFORM =~ /(darwin)/ ? @@dlg.show_modal() : @@dlg.show()
				
			end
			
		end
		
		def reset
			@status = 0
			@status_text = "Select the Deck Face"
		end
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh
			Sketchup::set_status_text @status_text
		end
		
		def onLButtonDown(flags, x, y, view)
			ph = view.pick_helper; ph.do_pick x,y; best=ph.best_picked
			if @status==0 && best.is_a?(Sketchup::Face)
				@mod.start_operation "Deck Builder",true
				@GW = 0.25.inch; @HW = @GW/2.0;
				ehsh={};best.outer_loop.edges.each{|e| ehsh[e]=e.length}
				edgs=ehsh.sort{|a,b| a[1]<=>b[1]}.map {|e| e[0]}
				while edgs.first.length<24.0.inch
					edgs.shift
				end
				@step_edge = edgs.first; @long_edge = edgs.last
				best.reverse! if best.normal.z > 0.0
				self.add_posts(best) if @do_p=='Yes'
				self.add_joist(best) if @do_j=='Yes'
				self.add_steps(best) if @do_s=='Yes'
				self.add_railing(best) if @do_r=='Yes'
				best.reverse! if best.normal.z < 0.0
				self.add_decking(best) if @do_d=='Yes'
				self.reset
				@mod.commit_operation
			end
		end
		
		def onRButtonDown(flags, x, y, view)
			@status==0 ? onCancel(flags,view) : self.reset
		end
		
		def onCancel(flags,view)
			Sketchup.send_action "selectSelectionTool:"
		end
		
		def deactivate(view)
			@@dlg.close if @@dlg; @@dlg=nil
			Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]=@current_units
		end
		 
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
		end
		#
		################################################
		#
		def actual_size(val)
			if @current_units<2
				case val
					when '2X2' then return 1.5,1.5
					when '2X4' then return 1.5,3.5
					when '2X6' then return 1.5,5.5
					when '2X8' then return 1.5,7.25
					when '2X10' then return 1.5,9.25
				end
			else
				x,y=val.split("X");
				return x.to_l,y.to_l
			end
		end
		
		def add_joist(face)
			joist=self.locate_joists(face)
			joist.entities.each{|e|
				next if face.classify_point(e.bounds.center) != 1
				next if self.distance_to_edge(face,e) < @JX
				p,v=e.line; xa=v.axes[0];ya=face.normal; pts=[]
				pts<<p.offset(xa,@JX/2).offset(v,@JX+0.01)
				pts<<pts[-1].offset(ya,@JY)
				pts<<pts[-1].offset(xa,-@JX)
				pts<<p.offset(xa,-@JX/2).offset(v,@JX+0.01)
				self.make_joist(pts,e.length-(@JX*2+0.02),v)
			}
			joist.erase!
			for l in face.loops
				for e in l.edges
					p,v=e.line; xa=v.axes[0];ya=face.normal; pts=[]
					tp = p.offset(v,@JY).offset(xa,@JX)
					xa.reverse! if face.classify_point(tp)==16
					pts<<p
					pts<<pts[-1].offset(xa,@JX)
					pts<<pts[-1].offset(ya,@JY)
					pts<<pts[-1].offset(xa,-@JX)
					self.make_joist(pts,e.length,v)
				end
			end
			# @do_j='No'
		end
		
		def locate_joists(face)
		
			lines=@ent.add_group; @lents=lines.entities; @ltran=lines.transformation
			joist=@ent.add_group; se=joist.entities;st=joist.transformation; joist.name="Joists"
			pl=face.plane;ctr=face.bounds.center; norm=face.normal;
			ctr=ctr.project_to_plane pl if !ctr.on_plane? pl; xa,ya,za=norm.axes;
			maxd = ((face.bounds.diagonal*2/@JS).floor)*@JS
			pt0=ctr.offset(xa.reverse,maxd/2).offset(ya.reverse,maxd/2)
			ny=(maxd/@JS).ceil
			for n in 1..ny
				pt1=pt0.offset(ya,maxd)
				@lents.add_face(pt0-norm,pt0+norm,pt1+norm,pt1-norm)
				pt0.offset!(xa,@JS)
			end
			fgrp=@ent.add_group face; fge=fgrp.entities; fgt=fgrp.transformation
			@lents.intersect_with(true, @ltran, se,st, false, fgrp)
			fgrp.explode; lines.erase!; #puts "#{se.length} joist"
			return joist
			
		end
		
		def distance_to_edge(face,edge)
			dmin=1e6; # find the minimum distance to a parallel face edge
			for loop in face.loops
				loop.edges.each{|e|
					next unless e.line[1].parallel?(edge.line[1]); 
					point=edge.bounds.center # only check edges parallel to face edge
					dis=point.distance_to_line e.line;
					dmin=[dis,dmin].min
				}
			end
			return dmin
		end
		
		def make_joist(pts,ppd,vec)
			grp=@ent.add_group; ge=grp.entities
			f=ge.add_face(pts); f.reverse! unless f.normal.samedirection?(vec)
			f.material = @mod.materials.current;f.pushpull ppd
			dim=[f.bounds.width,f.bounds.height,f.bounds.depth]
			dim.delete_if{|d| d==0}
			x=dim.min; y=dim.max
			grp.name="f2f-#{x.ceil}x#{y.ceil}-#{'%0.2f' % ppd}"
			# add "X" to ends of stud
			ge.each{|f|
				if f.is_a?(Sketchup::Face) && f.area==x*y
					v=f.vertices.collect{|v| v.position}
					ge.add_line(v[0],v[2])
					ge.add_line(v[1],v[3])
				end
			}
		end
		
		def add_posts(face)
			verts=face.outer_loop.vertices;pts=[];vecs=[];angs=[];last=verts.length-1
			0.upto(last) do |a|
				vec1 = (verts[a].position-verts[a-last].position).normalize
				vec2 = (verts[a].position-verts[a-1].position).normalize
				if vec1.parallel? vec2
					vec3 = Geom::Vector3d.new(vec1.y,-vec1.x,0)
					ang = 90.degrees
				else
					vec3=(vec1+vec2).normalize
					ang = vec1.angle_between(vec2)/2;
				end
				vec3.length = -(@JX/Math::sin(ang)+2.475);
				vec3.reverse! if face.classify_point(verts[a].position.offset(vec3))==16
				vecs << vec3; t = Geom::Transformation.new(vec3)
				pts << verts[a].position.transform(t)
				angs << ang
			end
			cmp = @mod.definitions[@PN];@posts=[]
			pts.each_with_index{|p,i| ya,za,xa=vecs[i].axes;
				pg=@ent.add_group; pge=pg.entities;
				tr=Geom::Transformation.axes(pts[i],xa,ya,za)
				ci=pge.add_instance(cmp,tr)
				case angs[i]
					when 0.768..0.803 # 44-46 degrees or square corner
						ci.transform! Geom::Transformation.rotation(pts[i],za,angs[i])
				end
				cde=ci.explode
				f=cde.grep(Sketchup::Face).reject!{|x|x.bounds.center.z>face.bounds.center.z}[0]
				f.reverse! if f.normal.z < 0.0
				face.bounds.min.z > 0.0 ? ppd=face.bounds.min.z : ppd=48
				# f.pushpull 36,true; 
				f.pushpull -ppd
				pge.grep(Sketchup::Face).each{|f| f.material=@mod.materials.current;self.ate(f)}
				@posts << pg
			}
			# @do_p='No'
		end
		
		def ate(f) #Align Texture to Edge
			if f.material && f.material.texture
				l=n=0;f.outer_loop.edges.each_with_index{|e,i| d=e.length;(n=i;l=d) if d>l}
				vector = f.edges[n].line[1]	# Align to longest bounding edge
				return unless f.normal.perpendicular? vector		# Skip if vector isn't in the plane of the face
				achorPoint = f.edges[n].line[0]					# Define point to rotate around
				textureWidth = f.material.texture.width
				vector.length = textureWidth					# Change vector's length to materials width
				points = [achorPoint, [0,0,0], [achorPoint[0]+vector[0],achorPoint[1]+vector[1],achorPoint[2]+vector[2]], [1,0,0]]	# Reposition material
				f.position_material(f.material, points, true)
			end
		end
		
		def add_steps(face)
			# construct steps
			face.bounds.min.z>0 ? tot_rise=face.bounds.min.z : tot_rise=48
			tot_run = tot_rise/Math.tan(40.degrees)
			steps = 0; rise=tot_rise
			while rise > 8.75.inch
				steps += 1
				rise = tot_rise/steps
			end
			tread=tot_run/steps;pts=[]; ang=Math.atan(rise/tread)
			tot_rise += @DX; tot_run = tot_rise/Math.tan(ang)
			sg=@ent.add_group; sge=sg.entities
			p0,v0=@step_edge.line
			y_axis,z_axis,x_axis=v0.axes
			y_axis.reverse! if face.classify_point(p0.offset(v0).offset(y_axis))==1
			width=@step_edge.length-(5.0.inch+@JX*2)
			p0.offset!(x_axis,2.5.inch+@JX); pts[0]=p0.offset(z_axis,@JX);p0.offset!(y_axis,@JX)
			top=@JY/Math.cos(40.degrees); btm=@JY/Math.sin(40.degrees)
			for i in 0...steps-1
				p1=p0.offset(z_axis,-rise)
				p2=p1.offset(x_axis,width)
				p3=p2.offset(y_axis,tread)
				p4=p1.offset(y_axis,tread)
				f=sge.add_face(p1,p2,p3,p4);
				f.material=@mod.materials.current
				f.pushpull @JX; p0=p4
			end
			pts[1]=pts[0].offset(z_axis,-top)
			pts[2]=pts[0].offset(z_axis,-tot_rise).offset(y_axis,tot_run-btm)
			pts[3]=pts[2].offset(y_axis,btm)
			f=sge.add_face(pts); f.reverse! if f.normal.samedirection? v0
			f.material=@mod.materials.current
			f.pushpull @JX; v0.length=width + @JX
			tr=Geom::Transformation.new(v0)
			pts.each{|p|p.transform! tr}
			f=sge.add_face(pts); f.reverse! if f.normal.samedirection? v0
			f.material=@mod.materials.current
			f.pushpull @JX
			sge.grep(Sketchup::Face).each{|f| f.material=@mod.materials.current;self.ate(f)}
			
			if @do_r =='Yes'# Add railing to steps
				v1=pts[0].vector_to(pts[3]);xa,ya,za=v1.axes; 
				srg=@ent.add_group;srge=srg.entities; sr_hgt=30.0.inch
				p0=pts[0].offset(v0,-0.75.inch);p5=pts[3].offset(v0,-0.75.inch)
				p2=p0.offset(z_axis,sr_hgt);p3=p5.offset(z_axis,sr_hgt);
				pts[0]=p2.offset(xa,+1.75.inch).offset(ya,+0.75.inch)
				pts[1]=p2.offset(xa,-1.75.inch).offset(ya,+0.75.inch)
				pts[2]=p2.offset(xa,-1.75.inch).offset(ya,-0.75.inch)
				pts[3]=p2.offset(xa,+1.75.inch).offset(ya,-0.75.inch)
				face=srge.add_face(pts); face.pushpull p2.distance(p3);# top rail
				dist=p2.distance(p3);spc=6.0.inch/Math.cos(ang);inc=dist;segs=1
				while inc > spc
					segs += 1; inc = dist/segs
				end
				inc=(dist-spc*(segs-2))/2; # add spindles
				p1=p0.offset(v1,inc); p4=p5.offset(v1,-inc)
				for n in 1...segs
					pts[0]=p1.offset(v0,+0.75.inch).offset(v1,+0.75.inch)
					pts[1]=p1.offset(v0,-0.75.inch).offset(v1,+0.75.inch)
					pts[2]=p1.offset(v0,-0.75.inch).offset(v1,-0.75.inch)
					pts[3]=p1.offset(v0,+0.75.inch).offset(v1,-0.75.inch)
					for i in 0..3
						pts[i+4]=pts[i].offset(z_axis,sr_hgt-0.9791.inch)
					end
					face=srge.add_face(pts[0..3]); face=srge.add_face(pts[4..7])
					for i in 0..3
						edge=srge.add_line(pts[i],pts[i+4]); 
						unless i==0
							edge.find_faces
						end
					end
					p1.offset!(v1,spc)
				end
				srge.grep(Sketchup::Face).each{|f| f.back_material=f.material=@mod.materials.current;self.ate(f)}
			end
			
		end
		
		def add_railing(face)
		
			unless @posts.length==0
				spt=@step_edge.start.position;ept=@step_edge.end.position
				for i in 0...@posts.length
					c0=@posts[i].bounds.center;c0.z=@posts[i].bounds.max.z-3.0.inch;
					c1=@posts[i-1].bounds.center;c1.z=@posts[i-1].bounds.max.z-3.0.inch
					v0=c0.vector_to c1;ya,za,xa = v0.axes;l0=[c0,za]; l1=[c1,za]
					next if @do_s=="Yes" && ((spt.distance_to_line(l0)<5.0.inch || ept.distance_to_line(l0)<5.0.inch) && \
						(spt.distance_to_line(l1)<5.0.inch || ept.distance_to_line(l1)<5.0.inch))
					p0=c0.offset(v0,1.75.inch);dist = c0.distance(c1) -3.5.inch;
					rg = @ent.add_group; rge=rg.entities
					p1=p0.offset(za,-3.0.inch).offset(ya,1.75.inch)
					p2=p1.offset(za,1.5.inch)
					p3=p2.offset(ya,-3.5.inch)
					p4=p3.offset(za,-1.5.inch)
					f=rge.add_face(p1,p2,p3,p4)
					f.reverse! unless f.normal.samedirection? v0
					f.pushpull dist
					p1=p0.offset(za,-27.0.inch).offset(ya,1.75.inch)
					p2=p1.offset(za,-1.5.inch)
					p3=p2.offset(ya,-3.5.inch)
					p4=p3.offset(za,1.5.inch)
					f=rge.add_face(p1,p2,p3,p4)
					f.reverse! unless f.normal.samedirection? v0
					f.pushpull dist; inc = dist; segs = 1
					while inc > 6.inch
						segs += 1; inc=dist/segs
					end
					cmp = @mod.definitions[@SN];ci=nil;#cmp=nil
					inc.step(dist,inc) do |d|
						if d < dist
							p1=p0.offset(za,-3.0.inch).offset(xa,d)
							unless cmp
								p1.offset!(ya,0.75.inch)
								p2=p1.offset(xa,1.5.inch)
								p3=p2.offset(ya,-1.5.inch)
								p4=p3.offset(xa,-1.5.inch)
								f=rge.add_face(p1,p2,p3,p4)
								f.reverse! if f.normal.samedirection? za
								f.pushpull 24.0.inch
							else
								tr=Geom::Transformation.axes(p1,xa,ya.reverse,za.reverse)
								ci=rge.add_instance(cmp,tr);ci.material=@mod.materials.current unless @SN=="spindle_a"
							end
						end
					end
					rge.grep(Sketchup::Face).each{|f| f.material=@mod.materials.current;self.ate(f)}
				end
				ci.definition.entities.grep(Sketchup::Face).each{|f| f.material=@mod.materials.current;self.ate(f)} if @SN=="spindle_a"
				# @do_r = 'No'
			else
				UI.messagebox "Railing requires Posts"
			end
		end
		
		def add_decking(face)
		
			pts=face.outer_loop.vertices.collect{|v| v.position}
			ndx=0; cp=1e6; ls=0.0; lp=pts.length-1; # assume regular 4 sided rectangle
			pts.each_with_index{|p,i| d=p.distance(pts[i-1])+p.distance(pts[i-lp]); ndx=i if d>ls; ls=[ls,d].max}
			ctr=face.bounds.center; ctr=ctr.project_to_plane face.plane unless ctr.on_plane? face.plane
			d1=pts[ndx].distance(pts[ndx-lp]); d2=pts[ndx].distance(pts[ndx-1]);
			if d1 >= d2
				@v1=pts[ndx].vector_to(pts[ndx-lp]).normalize
				pol=ctr.project_to_line([pts[ndx],pts[ndx-lp]])
				rot = @ROT.to_f
			else
				@v1=pts[ndx].vector_to(pts[ndx-1]).normalize
				pol=ctr.project_to_line([pts[ndx],pts[ndx-1]]);
				rot = -@ROT.to_f
			end
			@v2=pol.vector_to(ctr).normalize;@norm=face.normal; 
			if @ROT != "0"
				tr=Geom::Transformation.rotation(pts[ndx],@norm,rot.degrees)
				@v1.transform! tr; @v2.transform! tr
			end
			dx = face.bounds.diagonal*1.5; dy = @DY + @GW;
			nx=1;ny=(face.bounds.diagonal*1.5/dy).ceil;
			pt0 = ctr.offset(@v1,-dx*0.5).offset(@v2,-dy*(ny/2))
			@data=[];row=[]; cnt=0; max=nx*ny; #@ent.add_cpoint(pt0)
			for i in 0..ny
				p0=row[0]=pt0.offset(@v2,dy*i)
				row[1]=p0.offset(@v1,dx)
				@data[i]=row;row=[]
			end
			fg=@ent.add_group face;
			tg=@ent.add_group;tge=tg.entities;tgt=tg.transformation
			for i in 0...ny
				tge.add_face(self.makeaface(@data[i][0],@data[i][1],@norm))
			end
			@egrp=@ent.add_group;@ege=@egrp.entities;@egt=@egrp.transformation
			tge.intersect_with(true,tgt,@ege,@egt,false,fg)
			fg.explode; tg.erase!
			@ent.erase_entities(face);
			existing_faces=@ent.grep(Sketchup::Face); dump=@egrp.explode
			dump.grep(Sketchup::Edge).each{|e| e.find_faces};
			created_faces=@ent.grep(Sketchup::Face) - existing_faces;
			fgrp=@ent.add_group;@fge=fgrp.entities;
			created_faces.each{|f| 
				f.reverse! unless f.normal.samedirection? @norm; t=self.offset(f,-@HW)
				(t.reverse! unless t.normal.samedirection? @norm;t.material=@mod.materials.current; self.ate(t); t.pushpull(@DX)) if t
			}
			dump.grep(Sketchup::Edge).each{|e| @ent.erase_entities(e)}
			# @do_d = 'No'
		end
		
		def offset(face,dist)
			return nil unless ((dist.class==Fixnum || dist.class==Float || dist.class==Length) && dist!=0)
			begin
				verts=face.outer_loop.vertices;pts = [];
				0.upto(verts.length-1) do |a|
					vec1 = (verts[a].position-verts[a-(verts.length-1)].position).normalize
					vec2 = (verts[a].position-verts[a-1].position).normalize
					vec3 = (vec1+vec2).normalize
					if vec3.valid?
						ang = vec1.angle_between(vec2)/2
						vec3.length = dist/Math::sin(ang)
						t = Geom::Transformation.new(vec3)
						if pts.length > 0
							vec4 = pts.last.vector_to(verts[a].position.transform(t))
							if vec4.valid?
								unless (vec2.parallel?(vec4))
									t = Geom::Transformation.new(vec3.reverse)
								end
							end
						end
						pts.push(verts[a].position.transform(t))
					end
				end
				(pts.length > 2) ? (@fge.add_face(pts)) : (return nil)
			rescue
				puts "#{face} did not offset: #{pts}"
				return nil
			end
		end
	
		def makeaface(p1,p2,fn)
			pts=[];
			pts<<p1.offset(fn, 1)
			pts<<p2.offset(fn, 1)
			pts<<p2.offset(fn,-1)
			pts<<p1.offset(fn,-1)
		end
		
	end
	
end
